<!DOCTYPE html>
<html>
<title>OAuth - implicit flow</title>
<meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="/assets/w3.css">
<link rel="stylesheet" href="/assets/theme.css">
<link rel='stylesheet' href='https://fonts.googleapis.com/css?family=Open+Sans'>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<style>
html, body, h1, h2, h3, h4, h5 {font-family: "Open Sans", sans-serif}
</style>
<body class="w3-theme-l5">

<!-- Navbar -->
<div class="w3-top">
 <div class="w3-bar w3-theme-d2 w3-left-align w3-large">
  <a class="w3-bar-item w3-button w3-hide-medium w3-hide-large w3-right w3-padding-large w3-hover-white w3-large w3-theme-d2" href="javascript:void(0);" onclick="openNav()"><i class="fa fa-bars"></i></a>
  <a href="#" class="w3-bar-item w3-button w3-padding-large w3-theme-d4"><i class="fa fa-home w3-margin-right"></i>
    OAuth - Implicit flow
  </a>
 </div>
</div>


<!-- Page Container -->
<div class="w3-container w3-content" style="max-width:1400px;margin-top:80px">    
  <!-- The Grid -->
  <div class="w3-row">
    <!-- Left Column -->
    <div class="w3-col m3">
      <!-- Profile -->
      <div class="w3-card w3-round w3-white">
        <div class="w3-container">
         <h4 class="w3-center">OAuth Panel</h4>
         <hr>
         <p><i class="fa fa-shield fa-fw w3-margin-right w3-text-theme"></i> Status: 
        <em id="txt-status">-</em></p>
        </div>
      </div>
        <div class="w3-white">
          <a id="btn-perform-login" href="#" class="w3-button w3-block w3-theme-l1 w3-left-align"><i class="fa fa-circle-o-notch fa-fw w3-margin-right"></i> authenticate</a>
          <a href="/" class="w3-button w3-block w3-theme-l1 w3-left-align"><i class="fa fa-sign-out fa-fw w3-margin-right"></i> clear</a>
  </div>
<br>
      
      <!-- End Left Column -->
    </div>
    
    <!-- Middle Column -->
    <div class="w3-col m9">
    
      <div class="w3-row-padding ">
        <div class="w3-col m12">
          <div class="w3-card w3-round w3-white">
            <div class="w3-container w3-padding">
              <h4 class="w3-opacity">Flow</h6>
            </div>
          </div>
        </div>
      </div>


      <div id="nodata-container" class="w3-row-padding w3-container w3-hide ">

        <h6 class="w3-opacity">NO DATA</h6>
      </div>

<div id="response-container" class="w3-hide"> 

      <div class="w3-container w3-card w3-white w3-round w3-margin ">
        <h6 class="w3-opacity">Authentication URL</h6>
        <hr />
        
        <textarea id="txt-url"
          class="w3-border w3-padding" style="width: 100%; height: 6em;" readonly
          ></textarea>
        <hr />
        <p class="w3-padding" >Query string:</p>
        <textarea id="txt-options"
          class="w3-border w3-padding" style="width: 100%; height: 14em;" readonly
            ></textarea>
      </div>


      <div class="w3-container w3-card w3-white w3-round w3-margin">
        <h6 class="w3-opacity">Response</h6>
        <hr />
        <textarea id="txt-response"
          class="w3-border w3-padding" style="width: 100%; height: 14em;" readonly
            ></textarea>
        <hr />
      </div>
      
      <div class="w3-container w3-card w3-white w3-round w3-margin">
        <h6 class="w3-opacity">JWT</h6>
        <hr />
        <textarea id="txt-jwt"
          class="w3-border w3-padding" style="width: 100%; height: 13em;" readonly
            ></textarea>
        <hr />
        <h6 class="w3-opacity">Decoded JWT</h6>
        <textarea id="txt-decoded"
          class="w3-border w3-padding" style="width: 100%; height: 20em;" readonly
            ></textarea>
      </div>
  </div>
    <!-- End Middle Column -->
    </div>
    
    
  <!-- End Grid -->
  </div> 
<!-- End Page Container -->
</div>
<br>

<!-- Footer -->
<footer class="w3-container w3-theme-d3 w3-padding-16">
  <h5>OAuth sample</h5>
</footer>

<script
  src="https://code.jquery.com/jquery-3.5.1.min.js"
  integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0="
  crossorigin="anonymous"></script> 

<script>


const composeUrl = (baseUrl, params) => {
  let url = baseUrl;
  
  if (baseUrl.indexOf('?') < 0) {
    url += '?';
  } else if(baseUrl[baseUrl.length -1] !== '&') {
    url += '&';
  }

  Object.entries(params).forEach(([k, v]) => {
    url = `${url}${k}=${encodeURIComponent(v)}&`;
  });

  return url;
};

const parseHash = hash => {
  let txt = hash;
  if (txt[0] === '#') [_, txt] = txt.split('#');

  const result = {};
  
  txt.split('&').forEach(segment => {
    const [k, v] = segment.split('=');
    result[k] = v;
  });

  return result;
};

const decodeBase64json = (base64) => {
  return JSON.parse(atob(base64));
}

const decomposeJwt = (jwt) => {
  const [eHeader, ePayload] = jwt.split('.');
  return {
    header: decodeBase64json(eHeader),
    payload: decodeBase64json(ePayload),
  };
};


const l = console.log;

(()=>{
  const applicationId = '<%= env.APPLICATION_ID %>';
  const endpointAuth = '<%= env.ENDPOINT_AUTH%>';
  const redirectUrl = '<%= env.REDIRECT_URL %>';

  const oauthOptions = {
      'client_id': applicationId,
      'response_type': 'token id_token',     // flow type
      'redirect_uri': redirectUrl, // url to send the response to
      'scope': 'openid profile email', // list of scopes
      //'scope': 'openid profile email https://www.googleapis.com/auth/calendar.events.readonly',
      'nonce': 'xxadas' // <= should be random
    };

    const authUrl = composeUrl(endpointAuth, oauthOptions);

    $('#btn-perform-login').attr('href', authUrl);

    if (location.hash) {
      const params = parseHash(location.hash);
      l({params});
      
      $('#txt-url').val(authUrl);
      $('#txt-options').val(JSON.stringify(oauthOptions, null, 2));
      $('#txt-response').val(JSON.stringify(params, null, 2));
      $('#txt-jwt').val(params.id_token);
      $('#txt-decoded').val(JSON.stringify(decomposeJwt(params.id_token), null, 2));

      $('#txt-status').html('authenticated')
      $('#response-container').removeClass('w3-hide');
    } else {
      $('#nodata-container').removeClass('w3-hide');
      $('#txt-status').html('not authenticated')
    }


})();

</script>

</body>
</html> 

